using System;
using System.Net.WebSockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;

namespace BubbleSocketCore.Handlers
{
	class DummyHandler : IHandler
	{
		public void AddSocket(WebSocket webSocket)
		{
		}

		public bool IsListening(HttpRequest request)
		{
			return request.Path == "/ws";
		}

		public async Task Listen(HttpContext context, WebSocket webSocket, CancellationToken cancellationToken)
		{
			var buffer = new byte[1024 * 4];
			WebSocketReceiveResult result = await webSocket.ReceiveAsync(new ArraySegment<byte>(buffer), cancellationToken);
			while (!result.CloseStatus.HasValue)
			{
				var sendBuffer = Encoding.UTF8.GetBytes("websocket");
				await webSocket.SendAsync(new ArraySegment<byte>(sendBuffer, 0, sendBuffer.Length), result.MessageType, result.EndOfMessage, cancellationToken);

				result = await webSocket.ReceiveAsync(new ArraySegment<byte>(buffer), cancellationToken);
			}
			await webSocket.CloseAsync(result.CloseStatus.Value, result.CloseStatusDescription, cancellationToken);
		}
	}
}