using System.Collections.Generic;
using System.Net.WebSockets;
using System.Threading;
using BubbleSocketCore.Websocket;
using Microsoft.Extensions.Logging;

namespace BubbleSocketCore.Simulation {
public class DisconnectSimulationActionType : ISimulationAction
	{
		public readonly ILogger Logger;
		public DisconnectSimulationActionType(ILoggerFactory loggerFactory) {
			Logger = loggerFactory.CreateLogger("DisconnectSimulationActionType");
		}
		public object ParseMessageData(string rawString)
		{
			return null;
		}

		public void Run(WebSocket socket, object transmittedData)
		{
			List<object> payload = new List<object>();
			var manager = ConnectionManager.GetInstance();
			
			var currentConnection = manager.GetConnection(socket.GetHashCode());
			if(currentConnection == null) {
				//already been removed
				return;
			}
			Logger.LogDebug($"got disconnect {currentConnection}");

			//broadcast disconnect to everyone
			// payload.Add(currentConnection.entityId);
			// payload.Add(Simulation.latestFrame);
			// manager.GetActive().ForEach(connection =>
			// {
			// 	connection.SendAsync(SimulationActionType.OtherLeaveChannel, payload, CancellationToken.None);
			// });

			//remove session
			var connectionRemoved = manager.Remove(socket.GetHashCode());
			//remove entity from simulation
			// Simulation.GetInstance().RemoveEntityById(connectionRemoved.entityId);
		}
	}
}