using System.Collections.Generic;
using System.Net.WebSockets;
using System.Text.Json;
using System.Threading;
using BubbleSocketCore.Websocket;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;

namespace BubbleSocketCore.Simulation
{
	internal class JoinChannelSimulationActionType : ISimulationAction
	{
		public JoinChannelSimulationActionType(IConfiguration configuration, ILoggerFactory loggerFactory)
		{
			Configuration = configuration;
			LoggerFactory = loggerFactory;
		}

		public IConfiguration Configuration { get; }
		public ILoggerFactory LoggerFactory { get; }

		public object ParseMessageData(string rawString)
		{
			return JsonSerializer.Deserialize<List<JsonElement>>(rawString);
		}

		public async void Run(WebSocket socket, object transmittedData)
		{
			var connection = ConnectionManager.GetInstance().GetConnection(socket.GetHashCode());

			Dictionary<string, object> payload = new Dictionary<string, object>();
			await connection.SendAsync(SimulationActionType.JoinChannel, payload, CancellationToken.None);
		}
	}
}